<?php
class Product {
//    var $counter;
    var $names;
    var $descriptions;
    var $teasers;
    var $price;
    var $productPages;
    var $previewPicture;
    var $vat;
    var $separator;
    var $categories;
    var $stock_on_hand;
    var $weight;
    var $variants;
    var $uid;
    var $sortIndex;
    var $image;

    function Product() {
        $this->names = array();
        $this->descriptions = array();
        $this->teasers = array();
        $this->productPages = array();
        $this->categories = array();
        $this->variants = array();
        $this->uid = uniqid('p');

    }

    function getWeight(){
        if(!isset($this->weight)){$this->weight = 0;}
        return (float)$this->weight;
    }
    function getNet($vatRate){
        $net = $this->price/(100 + $vatRate)*100;
        return (float)$net;
    }

    function getGross(){
        return (float)$this->price;
    }

    function getName($language = null, $variant = null) {
        if($language === null){ $language = WRS_LANGUAGE; }
        $variantName = '';
        //     var_dump($this);
        if(isset($this->variants[$language][$variant])){
            $variantName = ' ('.$this->variants[$language][$variant]. ')';
        }
        if(!isset($this->names[$language])) {
            $langs = array_keys($this->names);
            $language = $langs[0];
        }

        return $this->names[$language]. $variantName;
    }
    function getVariantName($variant = 0){
        if(array_key_exists($variant, $this->variants[WRS_LANGUAGE])){
            return $this->variants[WRS_LANGUAGE][$variant];
        }
     }

     function getBestPicture(){
         if(isset($this->image) && strlen($this->image) > 0 && file_exists(WRS_IMAGE_PATH . $this->image)){
             return WRS_IMAGE_PATH . $this->image;
         }
         if(isset(   $this->previewPicture)
                  && strlen($this->previewPicture) > 0
                  && file_exists(WRS_IMAGE_PATH . $this->previewPicture)){


             return WRS_IMAGE_PATH . $this->previewPicture;
         }
        return  false;
     }


     function getImage(){
         if((isset($this->image)) && strlen($this->image) > 0 && ($this->image <> '')) {

            $image = '<img src="'.WRS_IMAGE_PATH.$this->image . '" alt="' .$this->getName(WRS_LANGUAGE) . '"  title="'.$this->getName(WRS_LANGUAGE). '" />';
            return $image;
        }
        return '';
     }
    
    function getDescription($language = null) {
        $language = ($language === null) ? WRS_LANGUAGE : $language;
        return isset($this->descriptions[$language]) ? stripslashes($this->descriptions[$language]) : '' ;
    }
     function getTeaser($language = null) {
        $language = ($language === null) ? WRS_LANGUAGE : $language;
       
        return isset($this->teasers[$language]) ? stripslashes($this->teasers[$language]) : '' ;
    }

    function getPageLink($language, $label = null){
        if(!$label){$label = $this->getName($language);}
        if($this->getPage($language)) {
            $label = "<a href=\"" . $this->productPages[$language][0] . "\">$label</a>";
        }
        return $label;
    }

    function getDetailsLink($language = null){
        $lang = ($language === null) ? WRS_LANGUAGE : $language;
         if(isset($this->descriptions[$lang]) && trim($this->descriptions[$lang]) != ''){
            return WRS_URL . '&wrsProduct=' . $this->uid;
        }
        return $this->getPage($language);
    }
    
    function getPage($language = null){
        if($language == null){
            $language = WRS_LANGUAGE;
        }

        if(isset($this->productPages[$language][0]) && trim($this->productPages[$language][0]) <> ''){
            return $this->productPages[$language][0];
        }
        return false;
    }


    function getPreviewPicture(){
        if((isset($this->previewPicture)) && ($this->previewPicture <> '')) {
            
            $image = '<img src="'.WRS_PREVIEW_PIC_PATH . $this->previewPicture. '" alt="' .$this->getName(WRS_LANGUAGE) .' - Preview"  title="'.$this->getName(WRS_LANGUAGE). '" />';
            return $image;
        }
        return '';
    }

    function getPreviewPictureName(){
        if((isset($this->previewPicture))) {
            return $this->previewPicture;
        }
        return '';
    }

    function getImageName(){
        if((isset($this->image))) {
            return $this->image;
        }
        return '';
    }
    
    function getVariants($language = null){
        if($language === null){ $language = WRS_LANGUAGE; }
        return isset($this->variants[WRS_LANGUAGE]) ? $this->variants[WRS_LANGUAGE] : array();
    }

    function getCategories($language = null){
        if($language === null){ $language = WRS_LANGUAGE; }
        return isset($this->categories[$language]) ? $this->categories[$language] : array();
    }

    function getProductPages($language = null){
        if($language === null){ $language = WRS_LANGUAGE; }
        if(isset($this->productPages[$language])){
            return $this->productPages[$language];
        }
        return array();
    }
    function hasVariants(){
        // return true;
        
        return (isset($this->variants[WRS_LANGUAGE]) && is_array($this->variants[WRS_LANGUAGE])) 
                ?  count($this->variants[WRS_LANGUAGE]) > 0
                : null;
    }

    function setName($name = 'No Name!', $language = null){
        if($language === null){ $language = WRS_LANGUAGE; }
        $this->names[$language] = $name;
        return;
    }

    function setDescription($description = '', $language = null){
        if($language === null){ $language = WRS_LANGUAGE; }
        $this->descriptions[$language] = $description;
        return;
    }

    function setTeaser($description = '', $language = null){
        if($language === null){ $language = WRS_LANGUAGE; }
        $this->teasers[$language] = $description;
        return;
    }

    function setPrice($price = 0.00){
        $price = str_replace(',', '.', $price);
        $this->price = (float)$price;
        return;
    }

    function setWeight($weight = 0.00){
        $weight = str_replace(',', '.', $weight);
        $this->weight = (float)$weight;
        return;
    }

    function setStockOnHand($quantity = 1){
        $this->stock_on_hand = (int)$quantity;
        return;
    }

    function setVat($rate = 'full'){
        $this->vat = (string)$rate;
        return;
    }

    function setVariants($variants = array(), $language = null){
         if($language === null){ $language = WRS_LANGUAGE; }
         if(is_array($variants)){
             if(count(($variants)) == 1){
                 trigger_error('Product:setVariants() only 1 variant has been passed - and ignored.');
                 $this->variants[$language] = array();
                 return;
             }
             $this->variants[$language] = $variants;
             return;
         }
         trigger_error('Product:setVariants() expects an array as first argument.');
         return;
    }

    function setProductPages($pages = array(), $language = null){
         if($language === null){ $language = WRS_LANGUAGE; }
         if(is_array($pages)){
             $this->productPages[$language] = $pages;
             return;
         }
         trigger_error('Product::setProductPages() expects an array as first argument.');
         return;
    }

    function setCategories($categories = array(), $language = null){
         if($language === null){ $language = WRS_LANGUAGE; }
         
         if(is_array($categories)){
             $this->categories[$language] = $categories;
             return;
         }
         trigger_error('Product:setCategories() expects an array as first argument.');
         return;
    }

    function setPreviewPic($pic = ''){
        $this->previewPicture = (string)$pic;
    }

    function setImage($pic = ''){
        $this->image = (string)$pic;
    }

    function isAvailable(){
        return isset($this->stock_on_hand) ? $this->stock_on_hand > 0 : true;
    }
}
?>
