<?php
class WRS_Frontend_View extends WRS_View {
    var $paymentHint;

    function WRS_Frontend_View(){
        parent::WRS_View();
        $this->templatePath = WRS_TEMPLATES_PATH. 'frontend/';
        $this->themePath = WRS_BASE_PATH . 'theme/frontend/';
    }
    function paymentHint(){
        if(count($this->payments) == 1){
            $hint = '';
        } else {
            $hint = $this->labels['choose_payment_mode'];
        }
        if(in_array('payment_mode', $this->missingData )){
            $hint = '<span class="wrsRequired">'.$hint.'</span>';
        }
        return $hint;
    }

    function contactInput($field){
        $html = '';
        $value = '';
        $label = $this->labels[$field];
        if($field == 'city'){
            $label = '<label for="'.$field.'" class="inline_form">'.$label. '</label>';
        }else {
            $label = '<label for="'.$field.'" class="data_form">'.$label. '</label>';
        }
        if(in_array($field,$this->missingData )){
            $label = '<span class="wrsRequired">'.$label.'</span>';
        }
        if(isset($_SESSION['wrsCustomer']->$field)){
            $value = $_SESSION['wrsCustomer']->$field;
        }
        switch ($field) {
            case 'zip_code':
                $params['size'] = 6;
                $params['class'] = 'inline_form';
                break;
            case 'city':
                $params['size'] = 20;
                break;
            default:
                $params['size'] = 34;
                break;
        }
        $params['id'] = $field;
        $html .= $label;
        $html .= $this->textinputNameValueLabel($field, $value, $field, $params);
        return $html;
    }

    function countriesSelectbox(){
        $countries = array();
        if(file_exists(WRS_COUNTRIES_FILE)){
            $temp = file(WRS_COUNTRIES_FILE);
            foreach($temp as $country){
                if(trim($country) !== ''){
                    $countries[] = $country;
                }
            }
        }else{return '';
        }
        if(count($countries) === 0){return '';}
        $html = '<label for="wrsCountries">' . $this->labels['country'] . ':&emsp;' ."\n"
        . '<select name="country" id="wrsCountries">';
        foreach($countries as $country){
            $html .= "\n\t".'<option';
            if($_SESSION['wrsCustomer']->country == trim($country)) {$html .= ' selected="selected"';}
            $html .= '>'.trim($country).'</option>';
        }
        $html .= "\n" . '</select>';
        return $html;
    }
    /**
     *
     * @return <string>
     *
     * TODO: leave url preparation to cms_bridge
     */
    function cosHint(){
        $cos_url = $this->cosUrl;
        $hint = $this->hints['cos_confirmation'];
        $name = $this->labels['cos_name'];
        if(strlen($cos_url) > 0) {
            $link = "<a href=\"$cos_url\" target=\"_blank\">$name</a>";
            $hint = str_replace($name, $link, $hint);
        }
        return $hint;
    }

    function defaultOrderSubmitForm(){
//just for fun
        printf( <<< STOP_FORM
<form action="" method="post" style="display: inline;">
    <input type="hidden" name="wrsCheckout" value="finish" />
    <input type="submit" class="shopButton"  value="%s" />
</form>
STOP_FORM
            , $this->buttons['send_order']);

    }
}
?>